////////////////////////////////////////////////////////////////////////////
//	File:		Delegates.h
//
//	Author:		Fabien Lebourg
//	E-mail:		fabien.lebourg@eole-soft.com
//
//	typedefs for Delegates
//
//	This code may be used in compiled form in any way you desire. This
//	file may be redistributed unmodified by any means PROVIDING it is
//	not sold for profit without the authors written consent, and
//	providing that this notice and the authors name and all copyright
//	notices remains intact.
//
//	An email letting me know how you are using it would be nice as well.
//
//	This file is provided "as is" with no expressed or implied warranty.
//	The author accepts no liability for any damage/loss of business that
//	this product may cause.


#ifndef _DELEGATES_H_
#define _DELEGATES_H_


#include "MT.h"
#include "Delegate0.h"
#include "Delegate1.h"
#include "Delegate2.h"


//*************************************************************************************
// Delegates classes:
//*************************************************************************************
//        |  No MT      |   MFC-MT      
// --------------------------------------
// 0 arg  | CDelegate0  | CMTDelegate0 
// 1 arg  | CDelegate1  | CMTDelegate1 
// 2 args | CDelegate2  | CMTDelegate2
//
//*************************************************************************************


// No Multi-Threading
typedef CDelegateImp0<CNoMT> CDelegate0;
template<class ARG> 
   class CDelegate1 : public CDelegateImp1<CNoMT, ARG> { };
template<class ARG1, class ARG2> 
   class CDelegate2 : public CDelegateImp2<CNoMT, ARG1, ARG2> { };

// Multi-Threading with MFC
#ifdef _MFC_VER
#include <afxmt.h>
   typedef CDelegateImp0<CCriticalSection> CMTDelegate0;
template<class ARG> 
   class CMTDelegate1 : public CDelegateImp1<CCriticalSection, ARG> { };
template<class ARG1, class ARG2> 
   class CMTDelegate2 : public CDelegateImp2<CCriticalSection, ARG1, ARG2> { };
#endif // _MSC_VER

#endif // _DELEGATES_H_